#include <ctype.h>
#include <stddef.h>
#include <string.h> /* strcmp(3) */
#include <sysexits.h>
#include <unistd.h> /* write(2) */
#include "libio.h" /* fdprint(3) */
#include "usefulmacros.h"

static char *program_name = "str";

static struct {
	char *name;
	int (*f)(int);
}ctypes[] = {
	{ "isalnum", isalnum },
	{ "isalpha", isalpha },
	{ "isblank", isblank },
	{ "iscntrl", iscntrl },
	{ "isdigit", isdigit },
	{ "isxdigit", isxdigit },
	{ "isgraph", isgraph },
	{ "islower", islower },
	{ "isprint", isprint },
	{ "ispunct", ispunct },
	{ "isspace", isspace },
	{ "isupper", isupper }
};

int main(int argc, char *argv[]){
	int i;
	int j;

	if(argc < 3){
error:		write(2, "Usage: ", 7);
		fdprint(2, argv[0] == NULL ? program_name : argv[0]);
		write(2, " [type] [string...]\n", 20);
		return EX_USAGE;
	}

	/* We could skip checking the first two characters and replace it with
	 * a single if(argv[1][0] == 'i' && argv[1][1] == 's') or something
	 * but it's simpler to just waste the cycles. */

	/* slow but for our purposes this is fine */
	for(i = 0; i < ARRAYLEN(ctypes); ++i)
		if(strcmp(argv[1], ctypes[i].name) == 0){
			i *= -1;
			break;
		}
	if(i > 0)
		goto error;
	i *= -1;

	for(argv += 2; *argv != NULL; ++argv)
		for(j = 0; argv[0][j] != '\0'; ++j)
			if(!ctypes[i].f(argv[0][j]))
				return 1;

	return 0;
}
